
package data;

import java.util.logging.FileHandler;
import java.util.logging.Logger;
//import java.util.logging.SimpleFormatter;
import java.io.*;
/**
 * Deze klasse moet zorgen dat alle logging juist gestart wordt en de juiste
 * handlers meer krijgt.
 * 
 * @author Rob Maas
 * @version 0.10
 */

public class LogHandling {
	private static Logger log;

	/**
	 * Maakt de logger en de handler aan voor de logging van de SMTP Server.
	 * @param logPath
	 */
	public static void startSMTPLogging(String logPath){	
		log = Logger.getLogger("SMTPServer");
		checkExistence(logPath, "log_smtp.html");
		try{
			FileHandler fhSMTPLogging = new FileHandler(logPath + "log_smtp.html");
			fhSMTPLogging.setFormatter(new HTMLFormatter());
			log.addHandler(fhSMTPLogging);
			log.info("Logging SMTPServer succesvol gestart.");
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}

	/**
	 * Maakt de logger en de handler aan voor de logging van de SMTP Server.
	 * @param logPath
	 */
	public static void startRelayLogging(String logPath){	
		log = Logger.getLogger("RelayServer");
		checkExistence(logPath, "log_relay.html");
		try{
			FileHandler fhSMTPLogging = new FileHandler(logPath + "log_relay.html");
			fhSMTPLogging.setFormatter(new HTMLFormatter());
			log.addHandler(fhSMTPLogging);
			log.info("Logging Relay Server succesvol gestart.");
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	/**
	 * Maakt de logger en de handler aan voor de logging van de POP3 Server.
	 * @param logPath
	 */
	public static void startPOP3Logging(String logPath){	
		log = Logger.getLogger("POP3Server");
		checkExistence(logPath, "log_pop3");
		try{
			FileHandler fhSMTPLogging = new FileHandler(logPath + "log_pop3.html");
			fhSMTPLogging.setFormatter(new HTMLFormatter());
			log.addHandler(fhSMTPLogging);
			log.info("Logging POP3Server succesvol gestart.");
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	/**
	 * Methode controleert of de directory en/of bestand al bestaat.
	 * Als bestand bestaat, word deze hernoemd naar bestand.oud.
	 * Hierbij wordt een evt. bestand.oud overschreven.
	 * 
	 * @param path
	 * @param filename
	 */
	private static void checkExistence(String path, String filename){
		//Directory controleren evt. aanmaken.
		File dir = new File(path);
		if (!dir.exists()){
			dir.mkdirs();
		}
		
		//Bestand controleren evt. hernoemen
		File file = new File(path+filename);
		File tmp;
		if (file.exists()){
			if ((tmp = new File(path + filename + "_old")).exists()){
				tmp.delete();
			}
			file.renameTo(new File(path + filename + "_old"));
		}
		
	}
}
