package relayServer;

import data.Message;

/**
 * WAIT state.
 * Vanuit de WAIT state wordt geprobeerd om zichzelf bekend te maken.
 * Dit gebeurd met HELO <hostnaam>
 * 
 * @version 0.50
 * TODO Hostnaam meesturen met HELO.
 */
public class WAITState extends RLYState {

	public WAITState(){
		state = true;
		sent = false;
	}
	
	public void doNextCmd(RelayServer rs, Message msg) {
		String line;
		String parser = " ";
		line = rs.getInput();
		
		line = line.substring(0, line.indexOf(parser));
		
		if (line.equals("220")){
			//Hier moet eigenlijk nog de domeinnaam achter.
			rs.setOutput("HELO "+rs.getLocalHostname());
			line = rs.getInput();
			line = line.substring(0, line.indexOf(parser));
			if (line.equals("250")){
				state = true;
				rs.setState(new HELOState());
			}
			else{
				state = false;
			}		
		}
		else{
			state = false;
		}		
	}
}
